import socket
import string
import time
s = socket.socket(AF_INET, SOCK_STREAM)

def connect(server, port=6667):
    s.connect((server, 6667))

def ready():
    x = s.recv(2048)
    if "376" in x:
        return True
    else:
        return False

def register(nick):
    s.send("NICK %s\r\n" % nick)
    s.send("USER  %s 8 *  : %s\r\n" % (nick, nick))

def join(channel):
    s.send("JOIN %s\r\n" % channel)

def send_msg(reciever, message):
    s.send("PRIVMSG %s :%s" % (reciever, message))

def send_raw(data):
    s.send(data)

def recieve():
    x = s.recv(2048)
    if x != "":
        return x

def username():
    x = s.recv(2048)
    return x.split("!")[0].strip(":")

def hostmask():
    return x.split("!")[1].split(" ")[0]

def message(message):
    x = s.recv(2048)
    msg = x.rpartition("PRIVMSG %s :" % (channel))
    return msg

def format_recv():
    return "<%s> %s" % (username(), message())

def timestamp():
    return "%s:%s:%s" % (time.localtime()[3], time.localtime()[4], time.localtime()[5])

def op(channel, reciever):
    s.send("MODE %s +o %s\r\n" % (channel, reciever))

def deop(channel, reciever):
    s.send("MODE %s -o %s\r\n" % (channel, reciever))

def voice(channel, reciever):
    s.send("MODE %s +v %s\r\n" % (channel, reciever))

def devoice(channel, reciever):
    s.send("MODE %s -v %s\r\n" % (channel, reciever))

def ban(channel, reciever):
    s.send("MODE %s +b %s!*@*\r\n" % (channel, reciever))

def kick(channel, nick, reason=None):
    s.send("KICK %s %s %s\r\n" % (channel, nick, reason))

def data_present(check):
    x = s.recv(2048)
    if check in x:
        return True
    else:
        return False

def nick(nick):
    s.send("NICK %s")

def disconnect(reason="Disconnected."):
    s.send("QUIT :%s" % reason)
    s.close()

if "PING" in s.recv(2048):
    ping = s.recv.rstrip()
    ping = split(ping)
    s.send("PONG %s" % ping[1])
